Attribute VB_Name = "Module2"
Option Explicit

Private Declare Function GetTickCount Lib "kernel32.dll" () As Long

Private Declare Function ULongAdd Lib "UArith.dll" ( _
    ByVal Augend As Long, _
    ByVal Addend As Long) As Long

Private Declare Function ULongSub Lib "UArith.dll" ( _
    ByVal Minuend As Long, _
    ByVal Subtrahend As Long) As Long

Private Sub Main()
    Dim t0 As Long
    Dim UlongA As Long, ULongB As Long, ULongC As Long
    Dim tULA As Double, tULS As Double

    'Unsigned add, DLL call.
    t0 = GetTickCount()
    UlongA = &H7FFFFFFF
    For ULongB = 1 To &H10000000
        ULongC = ULongAdd(UlongA, ULongB)
    Next
    tULA = CDbl(GetTickCount() - t0) / 1000

    'Unsigned subtract, DLL call.
    t0 = GetTickCount()
    UlongA = 0
    For ULongB = 1 To &H10000000
        ULongC = ULongSub(UlongA, ULongB)
    Next
    tULS = CDbl(GetTickCount() - t0) / 1000
    
    MsgBox Format$(&H10000000, "#,##0") & " iterations" & vbNewLine _
         & vbNewLine _
         & "Unsigned add, DLL call: " & Format$(tULA, "#,##0.0##") & " seconds" & vbNewLine _
         & "Unsigned subtract, DLL call: " & Format$(tULS, "#,##0.0##") & " seconds"
End Sub
